<template>
    <div class="row">
        <!-- Start col -->
        <div class="col-lg-8 col-xl-9">
            <div class="card m-b-30">
                <div class="card-header">
                    <h5 class="card-title">
                        Agregar cursos disponibles a la venta
                    </h5>
                </div>
                <div class="card-body">
                    <form>
                        <div class="form-group row">
                            <label
                                for="productTitle"
                                class="col-sm-12 col-form-label"
                                >Título del curso</label
                            >
                            <div class="col-sm-12">
                                <input
                                    v-model="curso.title"
                                    type="text"
                                    class="form-control font-20"
                                    id="productTitle"
                                    placeholder="Seleccionar curso de moodle"
                                />
                            </div>
                        </div>
                        <div class="form-group row">
                            <label class="col-sm-12 col-form-label"
                                >Descripción del curso</label
                            >
                            <div class="col-sm-12">
                                <div class="summernote">
                                    Insertar descripción de los productos
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
            <div class="card m-b-30">
                <div class="card-header">
                    <h5 class="card-title">Detalles Adicionales</h5>
                </div>
            </div>
            <div class="row">
                <div class="col-lg-12 col-xl-4">
                    <div class="card m-b-30">
                        <div class="card-body">
                            <div
                                class="nav flex-column nav-pills"
                                id="v-pills-product-tab"
                                role="tablist"
                                aria-orientation="vertical"
                            >
                                <a
                                    class="nav-link mb-2 active"
                                    id="v-pills-general-tab"
                                    data-toggle="pill"
                                    href="#v-pills-general"
                                    role="tab"
                                    aria-controls="v-pills-general"
                                    aria-selected="true"
                                    ><i class="feather icon-feather mr-2"></i
                                    >General</a
                                >
                                <a
                                    class="nav-link mb-2"
                                    id="v-pills-advanced-tab"
                                    data-toggle="pill"
                                    href="#v-pills-advanced"
                                    role="tab"
                                    aria-controls="v-pills-advanced"
                                    aria-selected="false"
                                    ><i class="feather icon-settings mr-2"></i
                                    >Advanced</a
                                >
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-lg-12 col-xl-8">
                    <div class="card m-b-30">
                        <div class="card-body">
                            <div
                                class="tab-content"
                                id="v-pills-product-tabContent"
                            >
                                <div
                                    class="tab-pane fade show active"
                                    id="v-pills-general"
                                    role="tabpanel"
                                    aria-labelledby="v-pills-general-tab"
                                >
                                    <form>
                                        <div class="form-group row">
                                            <label
                                                for="regularPrice"
                                                class="col-sm-4 col-form-label"
                                                >Price($)</label
                                            >
                                            <div class="col-sm-8">
                                                <input
                                                    type="text"
                                                    class="form-control"
                                                    id="regularPrice"
                                                    placeholder="100"
                                                    v-model="curso.price"
                                                />
                                            </div>
                                        </div>
                                        <div class="form-group row mb-0">
                                            <label
                                                for="salePrice"
                                                class="col-sm-4 col-form-label"
                                                >Sale Price($)</label
                                            >
                                            <div class="col-sm-8">
                                                <input
                                                    v-model="curso.price_sale"
                                                    type="text"
                                                    class="form-control"
                                                    id="salePrice"
                                                    placeholder="50"
                                                />
                                            </div>
                                        </div>
                                    </form>
                                </div>
                                <div
                                    class="tab-pane fade"
                                    id="v-pills-advanced"
                                    role="tabpanel"
                                    aria-labelledby="v-pills-advanced-tab"
                                >
                                    <form>
                                        <div class="form-group row mb-0">
                                            <label
                                                for="purchaseNote"
                                                class="col-sm-3 col-form-label"
                                                >Purchase note</label
                                            >
                                            <div class="col-sm-9">
                                                <textarea
                                                    class="form-control"
                                                    name="purchaseNote"
                                                    id="purchaseNote"
                                                    rows="3"
                                                    placeholder="Purchase note"
                                                ></textarea>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- End col -->
        <!-- Start col -->
        <div class="col-lg-4 col-xl-3">
            <div class="card m-b-30">
                <div class="card-header">
                    <div class="row align-items-center">
                        <div class="col-8">
                            <h5 class="card-title card-title font-18">
                                Categoría
                            </h5>
                        </div>
                        <div class="col-4">
                            <div class="card-statistics">
                                <ul
                                    class="nav nav-pills mb-0"
                                    id="pills-tab"
                                    role="tablist"
                                >
                                    <li class="nav-item">
                                        <a
                                            class="nav-link active"
                                            href="javascript.void(0);"
                                            role="tab"
                                            aria-selected="true"
                                            data-toggle="modal"
                                            data-target="#crearModal"
                                            >Agregar</a
                                        >
                                    </li>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="card-body">
                    <div
                        v-for="item in categorias"
                        :key="item.id"
                        class="custom-control custom-checkbox"
                    >
                        <input
                            type="checkbox"
                            class="custom-control-input"
                            v-bind:id="'category-' + item.id"
                            v-bind:value="item.id"
                            v-model="curso.category_id"
                            v-on:change.prevent="setCategory"
                        />
                        <label
                            class="custom-control-label"
                            v-bind:for="'category-' + item.id"
                            >{{ item.name }}</label
                        >
                    </div>
                </div>
            </div>
            <!-- agegar categoría -->
            <div
                class="modal fade"
                id="crearModal"
                tabindex="-1"
                role="dialog"
                aria-labelledby="crearModalLabel"
                aria-hidden="true"
            >
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="crearModalLabel">
                                Agregar nueva categoría
                            </h5>
                            <button
                                type="button"
                                class="close"
                                data-dismiss="modal"
                                aria-label="Close"
                            >
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <form method="POST">
                                <!-- Alerta de error -->
                                <div
                                    v-if="error"
                                    id="errorAlert"
                                    class="alert alert-danger alert-dismissible fade show"
                                    role="alert"
                                >
                                    <strong>Ohh no!</strong> {{ error }}.
                                    <button
                                        type="button"
                                        class="close"
                                        v-on:click.prevent="closeAlert()"
                                        aria-label="Close"
                                    >
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <!-- fin de error -->
                                <div class="form-group">
                                    <input
                                        type="text"
                                        placeholder="Ingrese el nombre de la categoría"
                                        class="form-control "
                                        name="category"
                                        v-model="newCategory.name"
                                        required
                                        autocomplete="category"
                                        autofocus
                                    />
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button
                                type="button"
                                class="btn btn-secondary"
                                data-dismiss="modal"
                            >
                                Cerrar
                            </button>
                            <button
                                v-on:click.prevent="createCategory()"
                                type="button"
                                class="btn btn-primary"
                            >
                                Crear categoría
                            </button>
                        </div>
                    </div>
                </div>
            </div>
            <!-- fin agrgar categoría  -->
            <!-- estado del curso -->
            <div class="card m-b-30">
                <div class="card-header">
                    <h5 class="card-title">Estado</h5>
                </div>
                <div class="card-body pt-3">
                    <select
                        v-model="curso.status"
                        class="form-control"
                        name="status"
                        id="status"
                    >
                        <option selected="selected" value="0"
                            >Sin disponibilidad</option
                        >
                        <option value="1">Disponible</option>
                    </select>
                </div>
            </div>
            <!-- fin del estado del curso  -->
            <!-- boton de Guardar -->
            <div class="card m-b-30">
                <div class="card-header">
                    <h5 class="card-title">Guardar</h5>
                </div>
                <div class="card-body pt-3">
                    <button
                        v-on:click.prevent="guardarCurso()"
                        class="btn btn-success btn-block"
                    >
                        GUARDAR
                    </button>
                </div>
            </div>
            <!-- fin de boton de Guardar -->
            <!-- imagen destacada -->
            <div class="card m-b-30">
                <div class="card-header">
                    <h5 class="card-title">Imagen principal del curso</h5>
                </div>
                <div class="card-body">
                    <div class="ecommerce-upload">
                        <!-- <form
                            class="dropzone dz-clickable"
                            method="POST"
                            v-on:action.prevent="uploadFile()"
                            enctype="multipart/form-data"
                        >
                            <div class="dz-default dz-message">
                                <p class="dash-analytic-icon">
                                    <i
                                        class="feather icon-plus primary-rgba text-primary"
                                    ></i>
                                </p>
                                <span>Upload Product Featured Image</span>
                            </div>
                        </form>
                        <img
                            src="\assets\images\dashboard\cloud.svg"
                            class="img-fluid"
                            alt="cloud"
                        /> -->
                        <figure>
                            <img
                                v-show="feature_image"
                                :src="imagen"
                                alt="foto principal del producto"
                                class="img-fluid"
                            />
                        </figure>
                        <input
                            type="file"
                            @change="obtenerImagen"
                            class="form-control"
                        />
                    </div>
                </div>
            </div>
            <!-- fin de imagen destacada -->
            <!-- Galería de imagenes  -->
            <!-- <div class="card m-b-30">
                <div class="card-header">
                    <h5 class="card-title">Galería de imágenes</h5>
                </div>
                <div class="card-body">
                    <div class="d-inline-block mb-1">
                        <img
                            src="\assets\images\ecommerce\product_gallery_01.jpg"
                            alt="Rounded Image"
                            class="img-fluid rounded"
                        />
                    </div>
                    <div class="d-inline-block mb-1">
                        <img
                            src="\assets\images\ecommerce\product_gallery_02.jpg"
                            alt="Rounded Image"
                            class="img-fluid rounded"
                        />
                    </div>
                    <div class="d-inline-block mb-1">
                        <img
                            src="\assets\images\ecommerce\product_gallery_03.jpg"
                            alt="Rounded Image"
                            class="img-fluid rounded"
                        />
                    </div>
                </div>
                <div class="card-footer">
                    <button
                        type="button"
                        class="btn btn-primary-rgba btn-lg btn-block"
                    >
                        Add Gallery
                    </button>
                </div>
            </div> -->
            <!-- fin de galeria de imagenes -->
            <div
                class="toast "
                role="alert"
                aria-live="assertive"
                aria-atomic="true"
                data-delay="60000"
                style="position: fixed; top: 60px; right: 30px;"
                id="bottom-right-toasts"
            >
                <div class="toast-header bg-danger-rgba">
                    <i class="feather icon-alert-triangle text-danger mr-2"></i>
                    <span class="toast-title mr-auto">Error</span>

                    <button
                        type="button"
                        class="ml-2 mb-1 close"
                        data-dismiss="toast"
                        aria-label="Close"
                    >
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="toast-body bg-danger-rgba">
                    <strong>{{ error }}</strong>
                </div>
            </div>
            <div
                class="toast "
                role="alert"
                aria-live="assertive"
                aria-atomic="true"
                data-delay="60000"
                style="position: fixed; top: 60px; right: 30px;"
                id="bottom-right-toasts-success"
            >
                <div class="toast-header bg-success-rgba">
                    <i
                        class="feather icon-alert-triangle text-success mr-2"
                    ></i>
                    <span class="toast-title mr-auto">Excelente!!</span>

                    <button
                        type="button"
                        class="ml-2 mb-1 close"
                        data-dismiss="toast"
                        aria-label="Close"
                    >
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="toast-body bg-success-rgba">
                    <strong>{{ error }}</strong>
                </div>
            </div>
        </div>
        <!-- End col -->
    </div>
</template>

<script>
export default {
    created: function() {
        this.getCategory();
    },
    mounted() {
        console.log("Component mounted.");
    },
    data() {
        return {
            curso: {
                moodle_id: Date.now(),
                category_id: [],
                status: 0,
                feature_image: "",
                gallery: [],
                title: "",
                description: "",
                price: "",
                price_sale: ""
            },
            feature_image: "",
            categorias: [],
            error: "",
            newCategory: {
                name: ""
            }
        };
    },
    methods: {
        getCategory() {
            var url = "/api/cursos/category";
            axios
                .get(url)
                .then(res => {
                    this.categorias = res.data;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        createCategory() {
            console.log(this.newCategory);
            var url = "/api/cursos/category";
            axios
                .post(url, this.newCategory)
                .then(res => {
                    if (res.data.error) {
                        this.error = res.data.error;
                    } else {
                        $("#crearModal").modal("toggle");
                        $(".modal-backdrop").remove();
                        this.getCategory();
                    }
                })
                .catch(err => {
                    console.log(err);
                });
        },
        setCategory(e) {
            if (e.target.checked) {
                this.curso.category_id = [parseInt(e.target.value)];
            }
        },
        guardarCurso() {
            if (!this.curso.category_id[0]) {
                this.error =
                    "Debe seleccionar una categoría para poder continuar";
                $("#bottom-right-toasts").toast("show");
            } else if (!this.curso.feature_image) {
                this.error =
                    "Debe seleccionar una imagen principal para poder continuar";
                $("#bottom-right-toasts").toast("show");
            } else if (!this.curso.title) {
                this.error = "Debe seleccionar un titulo para poder continuar";
                $("#bottom-right-toasts").toast("show");
            } else if (!this.curso.price) {
                this.error = "Debe seleccionar un precio para poder continuar";
                $("#bottom-right-toasts").toast("show");
            } else {
                if (this.curso.price_sale) {
                    if (
                        Number(this.curso.price_sale) > Number(this.curso.price)
                    ) {
                        this.error =
                            "El monto del precio de venta debe ser inferior al precio original del producto";
                        $("#bottom-right-toasts").toast("show");
                        return false;
                    }
                }
                let url = "/api/cursos/curso";
                let description = $(".note-editable.card-block").html();
                this.curso.description = description;
                console.log(this.curso);
                axios
                    .post(url, this.curso)
                    .then(res => {
                        this.error =
                            "Se ha creado el curso de manera exitosa en los proximos segúndos será redireccionado a la tabla de cursos";
                        $("#bottom-right-toasts-success").toast("show");
                        setTimeout(() => {
                            location.href = "/dashboard/cursos/disponibles";
                        }, 5000);
                    })
                    .catch(err => {
                        console.log(err);
                        this.error = err;
                        $("#bottom-right-toasts").toast("show");
                    });
            }
        },
        obtenerImagen(e) {
            let file = e.target.files[0];
            let url = "/api/files ";
            this.feature_image = file;

            let form = new FormData();
            form.append("file", this.feature_image);
            axios.post(url, form).then(res => {
                this.curso.feature_image = res.data;
                this.cargarImagen(file);
            });
        },
        cargarImagen(file) {
            let reader = new FileReader();
            reader.onload = e => {
                this.feature_image = e.target.result;
            };
            reader.readAsDataURL(file);
        }
    },
    computed: {
        imagen() {
            return this.feature_image;
        }
    }
};
</script>
